robert.tomczyk | a9b3ba6 | 2019-05-22 18:19:17 +0100 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | |
| 3 | # ============LICENSE_START======================================================= |
| 4 | # Copyright (C) 2019 The Nordix Foundation. All rights reserved. |
| 5 | # ================================================================================ |
| 6 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 7 | # you may not use this file except in compliance with the License. |
| 8 | # You may obtain a copy of the License at |
| 9 | # |
| 10 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 11 | # |
| 12 | # Unless required by applicable law or agreed to in writing, software |
| 13 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 14 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 15 | # See the License for the specific language governing permissions and |
| 16 | # limitations under the License. |
| 17 | # |
| 18 | # SPDX-License-Identifier: Apache-2.0 |
| 19 | # ============LICENSE_END========================================================= |
| 20 | |
| 21 | # |
robert.tomczyk | 4926d1c | 2019-07-05 09:52:58 +0100 | [diff] [blame] | 22 | # This script will take the single commit form the given Nordix Gerrit review |
| 23 | # and push it, and all its ancestor commit till $GERRIT_BRANCH, to OpenDaylight |
| 24 | # Gerrit. |
robert.tomczyk | a9b3ba6 | 2019-05-22 18:19:17 +0100 | [diff] [blame] | 25 | # Pre-requisites for script to run successfully: |
afenner | 9610398 | 2019-08-09 09:18:42 +0100 | [diff] [blame] | 26 | # - Author name in Nordix Gerrit equals LFID i.e. need to run "git config --global user.name <LFID>" |
robert.tomczyk | 4926d1c | 2019-07-05 09:52:58 +0100 | [diff] [blame] | 27 | # - infra public key on build server needs to be added to your users SSH |
| 28 | # Public Keys in OpenDaylight Gerrit |
robert.tomczyk | a9b3ba6 | 2019-05-22 18:19:17 +0100 | [diff] [blame] | 29 | # |
robert.tomczyk | 4926d1c | 2019-07-05 09:52:58 +0100 | [diff] [blame] | 30 | set -euxo pipefail |
robert.tomczyk | a9b3ba6 | 2019-05-22 18:19:17 +0100 | [diff] [blame] | 31 | |
robert.tomczyk | 4926d1c | 2019-07-05 09:52:58 +0100 | [diff] [blame] | 32 | cd "$WORKSPACE" |
robert.tomczyk | a9b3ba6 | 2019-05-22 18:19:17 +0100 | [diff] [blame] | 33 | |
robert.tomczyk | 4926d1c | 2019-07-05 09:52:58 +0100 | [diff] [blame] | 34 | opendaylight_gerrit_base='git.opendaylight.org:29418' |
| 35 | nordix_gerrit_rest='https://gerrit.nordix.org' |
robert.tomczyk | a9b3ba6 | 2019-05-22 18:19:17 +0100 | [diff] [blame] | 36 | |
robert.tomczyk | 4926d1c | 2019-07-05 09:52:58 +0100 | [diff] [blame] | 37 | echo >&2 "Collecting information about what and how to push towards OpenDaylight" |
robert.tomczyk | a9b3ba6 | 2019-05-22 18:19:17 +0100 | [diff] [blame] | 38 | |
robert.tomczyk | 4926d1c | 2019-07-05 09:52:58 +0100 | [diff] [blame] | 39 | # The git hash of the commit in the review this job runs on |
| 40 | commit_hash="$GERRIT_PATCHSET_REVISION" |
robert.tomczyk | a9b3ba6 | 2019-05-22 18:19:17 +0100 | [diff] [blame] | 41 | |
robert.tomczyk | 4926d1c | 2019-07-05 09:52:58 +0100 | [diff] [blame] | 42 | # GERRIT_PROJECT is in the form of opendaylight/<opendaylight-project> |
| 43 | opendaylight_project=$(echo "$GERRIT_PROJECT" | cut -d/ -f2- ) |
robert.tomczyk | a9b3ba6 | 2019-05-22 18:19:17 +0100 | [diff] [blame] | 44 | |
afenner | 9610398 | 2019-08-09 09:18:42 +0100 | [diff] [blame] | 45 | # original way to get user name based on nordix id replaced by method below |
robert.tomczyk | 4926d1c | 2019-07-05 09:52:58 +0100 | [diff] [blame] | 46 | # Nordix Gerrit can map the email address of the user pushed the change to |
| 47 | # the review to the Gerrit username of the account in Nordix Gerrit. This |
| 48 | # should match with the Gerrit username in the OpenDaylight Gerrit. |
afenner | 9610398 | 2019-08-09 09:18:42 +0100 | [diff] [blame] | 49 | #username=$( |
| 50 | # curl -s -H 'Accept: application/json' \ |
| 51 | # "$nordix_gerrit_rest/accounts/?q=email:$GERRIT_EVENT_ACCOUNT_EMAIL&o=DETAILS" \ |
| 52 | # | tee /dev/stderr | tail -1 | jq -r '.[0].username') |
| 53 | |
| 54 | # read user name from the commit details which allows nordix user name to be different to lfid |
| 55 | username=$(git show -s --pretty=%an) |
| 56 | |
| 57 | pattern=" " |
| 58 | if [[ "$username" =~ $pattern ]] |
| 59 | then |
| 60 | echo "Incorrect username, use Linux Foundation ID as git user.name when pushing to Nordix" |
| 61 | echo "Use command git config --global user.name <LFID>" |
| 62 | exit 1 |
| 63 | fi |
robert.tomczyk | 4926d1c | 2019-07-05 09:52:58 +0100 | [diff] [blame] | 64 | |
| 65 | opendaylight_remote_url="ssh://$username@$opendaylight_gerrit_base/$opendaylight_project" |
| 66 | |
| 67 | # GERRIT_BRANCH is the _intended_ branch of the commit under review |
| 68 | # E.g. git push HEAD:refs/for/master => GERRIT_BRANCH='master' |
| 69 | # GERRIT_TOPIC is the rest of the refspec after GERRIT_BRANCH when the topic |
| 70 | # is set for the change. |
| 71 | if [ -z "${GERRIT_TOPIC:-}" ] ; then |
robert.tomczyk | 40f6015 | 2020-10-13 11:03:13 +0100 | [diff] [blame] | 72 | refspec="${commit_hash}:refs/for/${GERRIT_BRANCH}" |
robert.tomczyk | a9b3ba6 | 2019-05-22 18:19:17 +0100 | [diff] [blame] | 73 | else |
robert.tomczyk | 40f6015 | 2020-10-13 11:03:13 +0100 | [diff] [blame] | 74 | refspec="${commit_hash}:refs/for/${GERRIT_BRANCH}%topic=${GERRIT_TOPIC}" |
robert.tomczyk | a9b3ba6 | 2019-05-22 18:19:17 +0100 | [diff] [blame] | 75 | fi |
| 76 | |
robert.tomczyk | 4926d1c | 2019-07-05 09:52:58 +0100 | [diff] [blame] | 77 | echo >&2 "Pushing to OpenDaylight" |
robert.tomczyk | a9b3ba6 | 2019-05-22 18:19:17 +0100 | [diff] [blame] | 78 | |
robert.tomczyk | 4926d1c | 2019-07-05 09:52:58 +0100 | [diff] [blame] | 79 | # do not fail if git push fails as in case of no new changes we want to succeed. See below. |
| 80 | set +o pipefail |
| 81 | |
| 82 | git push "$opendaylight_remote_url" "$refspec" 2>&1 | tee push_result.txt |
| 83 | push_result=${PIPESTATUS[0]} |
| 84 | |
| 85 | # make the job a success if the above git push fails due to no new changes are needed |
| 86 | # to be created upstream. This will be useful when we switch to automatic triggering |
| 87 | # of the push-upstream for each patch set and jobs on different commits in a same chain |
| 88 | # will race with each other to push parts of the chain |
| 89 | if [ $push_result -ne 0 ]; then |
| 90 | grep '(no new changes)' push_result.txt |
robert.tomczyk | a9b3ba6 | 2019-05-22 18:19:17 +0100 | [diff] [blame] | 91 | fi |